image: node:latest

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
      - ${PROJECT_NAME}/bin

stages:
  - build
  - test
  - docker
  - deploy

install_dependencies:
  stage: build
  script:
    - rm ./package-lock.json
    - npm install
  artifacts:
    paths:
      - node_modules/
      - dist

build-push:
  image: docker:latest
  services:
      - docker:dind
  before_script:
      - "docker login -u ${DOCKER_USERNAME} -p ${DOCKER_PASSWORD}"
  script:
      - rm ./package-lock.json
      - "docker build . -f .Dockerfile -t joshuakeulers/api-gateway:latest"
      - "docker push joshuakeulers/api-gateway:latest"
  stage: docker

kubernetes-apply:
  image: henry40408/doctl-kubectl:latest
  before_script:
      - doctl auth init -t ${DOCTL_ACCESS}
      - doctl kubernetes cluster kubeconfig save ${KUBECTL_CONNECT}
  script:
      - kubectl apply -f ./deploy/k8s-deploy.yaml
  stage: deploy

